/*
keylight by pps
started: 22.07.2025
*/

;	@com.wudsn.ide.asm.hardware=ATARI8BIT

	icl 'atari.hea'

BEGIN	equ $2000				;start address

;----------
;Definitionen für die Tasten, die nicht in 764 sind
keyRESET	= $ff	;-> kann man nicht so recht direkt abfragen oder muss die RESET Routine verbiegen
keySTART	= 1
keySELECT	= 2
keyOPTION	= 3
keyHELP		= 5
keyBREAK	= 6
;----------
	.zpvar	.byte	regA,regX,regY
	.zpvar	.byte	actscreen		;0 -> 11/9, 1->9/11
	.zpvar	.byte	lastkey,actkey		;lastkey entweder 0 (nichts) oder eben zuletzt gedrückte Taste, actkey halt aktuelle Taste
	.zpvar	.byte	keyaction		;0 -> nichts passiert (Taste ist noch gedrückt), 1 -> Taste losgelassen und ACTION
;----------
; ---	MAIN PROGRAM
	org BEGIN
	.proc ant
:2	.he 70
	.he 46
	.wo scr_title
	.he 20 01
chg	.wo ant_even
	.endp
;----------
	.proc ant_input
;--- input area
	.he 80 10 42
	.wo scr_input
;	.he 10
;:6	.he 02
;---
	.he 01
chg	.wo ant_farb_even
;---
;	.he 41
;	.wo ant
	.endp
;------------
	.proc ant_even
;--- keyboard + colors
	.rept 6, #
;---
	.he 10 80

	.he 4f
	.wo scr_16c+(#*40)
	.he 4f
	.wo scr_16g+(#*40)
	
	.he 4f
	.wo scr_16c+(#*40)
	.he 4f
	.wo scr_16g+(#*40)
	.he 4f
	.wo scr_16c+(#*40)
	
	.he 80 42
	.wo scr_keys+(#*40)
;---
	.endr
	.he 01
	.wo ant_input
	.endp
;------------
	.proc ant_odd
;--- keyboard + colors
	.rept 6, #
;---
	.he 10 80

	.he 4f
	.wo scr_16g+(#*40)
	.he 4f
	.wo scr_16c+(#*40)
	
	.he 4f
	.wo scr_16g+(#*40)
	.he 4f
	.wo scr_16c+(#*40)
	.he 4f
	.wo scr_16g+(#*40)
	
	.he 80 42
	.wo scr_keys+(#*40)
;---
	.endr
	.he 01
	.wo ant_input
	.endp
;------------
	.proc ant_farb_even
	.he 80
;---
	.rept 16, #
	.he 4f
	.wo scr_Farbtabelle_g+(#*40)
	.he 4f
	.wo scr_Farbtabelle_c+(#*40)
	.he 4f
	.wo scr_Farbtabelle_g+(#*40)
	.he 4f
	.wo scr_Farbtabelle_c+(#*40)
	.he 00
	.endr
;---
	.he 41
	.wo ant
	.endp
;------------
	.proc ant_farb_odd
	.he 80
;---
	.rept 16, #
	.he 4f
	.wo scr_Farbtabelle_c+(#*40)
	.he 4f
	.wo scr_Farbtabelle_g+(#*40)
	.he 4f
	.wo scr_Farbtabelle_c+(#*40)
	.he 4f
	.wo scr_Farbtabelle_g+(#*40)
	.he 00
	.endr
;---
	.he 41
	.wo ant
	.endp
;------------
	.proc main
	mva #0 559
	sta actscreen
	mwa #ant 560
	lda #7			;VBI
	ldx >vbi		;wird
	ldy <vbi		;jetzt
	jsr setvbv		;initialisiert
	mva #$c0 nmien		;DLI + VBI an
	mva #34 559

;--- set key variables
	mva #0 keyaction
	sta lastkey
;---
mainloop
	lda vcount
	bne mainloop
	jsr consoltest
	jsr keytest

	jmp mainloop
	.endp
;------------
	.proc keytest
	lda 764
	cmp #255
	beq out
	cmp #key_esc
	bne @+
	jmp $e477
@	cmp #key_space

	mva #255 764
out	rts
	.endp
;------------
	.proc consoltest
	lda consol
	tax
	and #4				;OPTION?
	bne t_sel
	
t_sel	txa
	and #2				;SELECT?
	bne t_sta

t_sta	txa
	and #1				;START?
	bne out

out	rts
	.endp
;------------
	.proc vbi
	lda actscreen
	beq even
	cmp #1
	beq odd
	mva #0 actscreen
even	mwa #ant_even ant.chg
	mwa #ant_farb_even ant_input.chg
	jmp w
odd
	mwa #ant_odd ant.chg
	mwa #ant_farb_odd ant_input.chg

w	mwa #dli 512
	mva #@dmactl(standard|dma) dmactl	;set new screen width
	mva #0 colbak
	sta color2
	mva #$e color1
	mva #$e0 chbase

	jmp xitvbv
	.endp
;------------
	.proc dli_even
	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	rts
	.endp
;------------
	.proc dli_odd
	sta wsync
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	rts
	.endp
;------------
;---line0
	.proc dli
	sta rega

	lda actscreen
	beq @+
;	jsr dli_odd
	sta wsync
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
;	mva #6 colbak
	jmp o
@;	jsr dli_even
	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
o
	mwa #dli1 512
	lda rega
	rti
	.endp
;------------
	.proc dli1
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli2 512
	lda rega
	rti
	.endp
;------------
;---line1
	.proc dli2
	sta rega

	lda actscreen
	beq @+
;	jsr dli_odd
	sta wsync
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
;	mva #6 colbak
	jmp o
@;	jsr dli_even
	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
o
	mwa #dli3 512
	lda rega
	rti
	.endp
;------------
	.proc dli3
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli4 512
	lda rega
	rti
	.endp
;------------
;---line2
	.proc dli4
	sta rega

	lda actscreen
	beq @+
;	jsr dli_odd
	sta wsync
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
;	mva #6 colbak
	jmp o
@;	jsr dli_even
	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
o
	mwa #dli5 512
	lda rega
	rti
	.endp
;------------
	.proc dli5
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli6 512
	lda rega
	rti
	.endp
;------------
;---line3
	.proc dli6
	sta rega

	lda actscreen
	beq @+
;	jsr dli_odd
	sta wsync
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
;	mva #6 colbak
	jmp o
@;	jsr dli_even
	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
o
	mwa #dli7 512
	lda rega
	rti
	.endp
;------------
	.proc dli7
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli8 512
	lda rega
	rti
	.endp
;------------
;---line4
	.proc dli8
	sta rega

	lda actscreen
	beq @+
;	jsr dli_odd
	sta wsync
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
;	mva #6 colbak
	jmp o
@;	jsr dli_even
	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
o
	mwa #dli9 512
	lda rega
	rti
	.endp
;------------
	.proc dli9
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli10 512
	lda rega
	rti
	.endp
;------------
;---line5
	.proc dli10
	sta rega

	lda actscreen
	beq @+
;	jsr dli_odd
	sta wsync
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
;	mva #6 colbak
	jmp o
@;	jsr dli_even
	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
o
	mwa #dli11 512
	lda rega
	rti
	.endp
;------------
	.proc dli11
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli_input 512
	lda rega
	rti
	.endp
;------------
	.proc dli_input
	sta rega

	mva #$e0 chbase
	sta wsync

;---
;	inc actscreen

	mwa #dli_farbtabelle 512
	lda rega
	rti
	.endp
;------------
	.proc dli_farbtabelle
	sta rega

	lda actscreen
	jeq @+
;	jsr dli_odd
	sta wsync
	.rept 16
	.rept 2
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	.endr
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
;	mva #6 colbak
	jmp o
@;	jsr dli_even
	sta wsync
	.rept 16
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	.endr
o
;---
	inc actscreen

	mwa #dli_farbtabelle 512
	lda rega
	rti
	.endp
;------------
	.proc scr_keys
	ins "gfx/keylight.scr"
	.endp
	.proc scr_16g
;--- line 0
:17	.he 00
help	.he 22
:3	.he 00
start	.he 44
:3	.he 00
select	.he 66
:3	.he 00
option	.he 44
:3	.he 00
reset	.he aa
:6	.he 00
;--- line 1
:5	.he 00
esc	.he 66
	.he 00
one	.he 66
	.he 00
two	.he 66
	.he 00
three	.he 66
	.he 00
four	.he 66
	.he 00
fife	.he 66
	.he 00
six	.he 66
	.he 00
seven	.he 66
	.he 00
eight	.he 66
	.he 00
nine	.he 66
	.he 00
zero	.he 66
	.he 00
bleft	.he 66
	.he 00
bright	.he 66
	.he 00
delete	.he 66
:2	.he 00
break	.he 66
:5	.he 00
;--- line 2
:6	.he 00
tab	.he 00
	.he 00
q	.he 11
	.he 00
w	.he 22
	.he 00
e	.he 33
	.he 00
r	.he 44
	.he 00
t	.he 55
	.he 00
y	.he 66
	.he 00
u	.he 77
	.he 00
i	.he 88
	.he 00
o	.he 99
	.he 00
p	.he aa
	.he 00
minus	.he bb
	.he 00
even	.he cc
:2	.he 00
return	.he dd
:6	.he 00
;--- line 3
:6	.he 00
control	.he dd
:2	.he 00
a	.he cc
	.he 00
s	.he bb
	.he 00
d	.he aa
	.he 00
f	.he 99
	.he 00
g	.he 88
	.he 00
h	.he 77
	.he 00
j	.he 66
	.he 00
k	.he 55
	.he 00
l	.he 44
	.he 00
semi	.he 33
	.he 00
plus	.he 22
	.he 00
mul	.he 11
:2	.he 00
caps	.he 00
:6	.he 00
;--- line 4
:5	.he 00
lshift	.he 11
:3	.he 00
z	.he 22
	.he 00
x	.he 33
	.he 00
c	.he 44
	.he 00
v	.he 55
	.he 00
b	.he 66
	.he 00
n	.he 77
	.he 00
m	.he 88
	.he 00
komma	.he 99
	.he 00
dot	.he aa
	.he 00
slash	.he bb
:2	.he 00
rshift	.he cc
:2	.he 00
inv	.he dd
:8	.he 00
;--- line 5
:9	.he 00
space1	.he dd
:6	.he 00
space2	.he 44
:6	.he 00
space3	.he aa
:18	.he 00
	.endp
;------------
	.proc scr_16c
;--- line 0
:17	.he 00
help	.he 22	;red
:3	.he 00
start	.he bb	;green
:3	.he 00
select	.he 88	;blue
:3	.he 00
option	.he 44	;purple
:3	.he 00
reset	.he ee	;yellow
:6	.he 00
;--- line 1
:5	.he 00
esc	.he 11	;all colors
	.he 00
one	.he 22
	.he 00
two	.he 33
	.he 00
three	.he 44
	.he 00
four	.he 55
	.he 00
fife	.he 66
	.he 00
six	.he 77
	.he 00
seven	.he 88
	.he 00
eight	.he 99
	.he 00
nine	.he aa
	.he 00
zero	.he bb
	.he 00
bleft	.he cc
	.he 00
bright	.he dd
	.he 00
delete	.he ee
:2	.he 00
break	.he ff
:5	.he 00
;--- line 2
:6	.he 00
tab	.he 22	;all red
	.he 00
q	.he 22
	.he 00
w	.he 22
	.he 00
e	.he 22
	.he 00
r	.he 22
	.he 00
t	.he 22
	.he 00
y	.he 22
	.he 00
u	.he 22
	.he 00
i	.he 22
	.he 00
o	.he 22
	.he 00
p	.he 22
	.he 00
minus	.he 22
	.he 00
even	.he 22
:2	.he 00
return	.he 22
:6	.he 00
;--- line 3
:6	.he 00
control	.he bb	;all green
:2	.he 00
a	.he bb
	.he 00
s	.he bb
	.he 00
d	.he bb
	.he 00
f	.he bb
	.he 00
g	.he bb
	.he 00
h	.he bb
	.he 00
j	.he bb
	.he 00
k	.he bb
	.he 00
l	.he bb
	.he 00
semi	.he bb
	.he 00
plus	.he bb
	.he 00
mul	.he bb
:2	.he 00
caps	.he bb
:6	.he 00
;--- line 4
:5	.he 00
lshift	.he 88	;all blue
:3	.he 00
z	.he 88
	.he 00
x	.he 88
	.he 00
c	.he 88
	.he 00
v	.he 88
	.he 00
b	.he 88
	.he 00
n	.he 88
	.he 00
m	.he 88
	.he 00
komma	.he 88
	.he 00
dot	.he 88
	.he 00
slash	.he 88
:2	.he 00
rshift	.he 88
:2	.he 00
inv	.he 88
:8	.he 00
;--- line 5
:9	.he 00
space1	.he ee
:6	.he 00
space2	.he 33
:6	.he 00
space3	.he 55
:18	.he 00
	.endp
;------------
	.proc scr_title
	dta "set keyboard colors "
	.endp
;------------
	.proc scr_input
	dta "       press key to change color        "
;:6	dta "0123456789012345678901234567890123456789"
	.endp
;------------
	.align $0400
	.proc fnt
	ins "gfx/keylight.fnt"
	.endp
;------------
	.align $1000
	.proc scr_Farbtabelle_c

:4	.he 00
:16	.he 00 00
:4	.he 00
:4	.he 00
:16	.he 00 11
:4	.he 00
:4	.he 00
:16	.he 00 22
:4	.he 00
:4	.he 00
:16	.he 00 33
:4	.he 00
:4	.he 00
:16	.he 00 44
:4	.he 00
:4	.he 00
:16	.he 00 55
:4	.he 00
:4	.he 00
:16	.he 00 66
:4	.he 00
:4	.he 00
:16	.he 00 77
:4	.he 00
:4	.he 00
:16	.he 00 88
:4	.he 00
:4	.he 00
:16	.he 00 99
:4	.he 00
:4	.he 00
:16	.he 00 aa
:4	.he 00
:4	.he 00
:16	.he 00 bb
:4	.he 00
:4	.he 00
:16	.he 00 cc
:4	.he 00
:4	.he 00
:16	.he 00 dd
:4	.he 00
:4	.he 00
:16	.he 00 ee
:4	.he 00
:4	.he 00
:16	.he 00 ff
:4	.he 00

	.endp
;------------
	.proc scr_Farbtabelle_g
	.rept 16
:4	.he 00
	.rept 16, #
	dta b(0),b(#*$11)
	.endr
:4	.he 00
	.endr
	.endp
;------------
	run main